function [mean_amp_abs, mean_amp, dif_front, sum_front_std,r_steepnes] = Pwave(ecg,peaks,fs)
    % FOR TEST 
    %load A00002.mat; ecg = val; peaks = hybrid_detection(ecg,300);
    %	 [mean_amp_abs, mean_amp, dif_front, sum_front_std,r_steepnes] = Pwave(ecg,peaks,fs);
    
    %normalization
    ecg = (ecg-mean(ecg))/std(ecg);
    
    %%meanQRS $ stdmeanQRS
    
    margin = floor(0.25*fs); 
    qrs_vector = zeros(length(peaks)-2,2*margin+1);
    
    % zabezpieczenie przed exceeds matrix dimensioon 
    if peaks(end)+margin>length(ecg)
        peaks(end) = [];
    end
    if peaks(1)-margin<=0
        peaks(1) = [];
    end
        
    for i = 1:length(peaks)-1
       qrs_vector(i,:) =  ecg(peaks(i)-margin: peaks(i)+margin)';
    end
    meanQRS = mean(qrs_vector,1);
    stdQRS = std(qrs_vector,1);
    
    % invertion of QRS 
    if(max((meanQRS))<abs(min(meanQRS))); meanQRS = -meanQRS; end
    
    
    %% peak finding module 
    % find R 
    [R_val,R_idx] = max(meanQRS);
    % find Q 
    d_back = 9;
    
    if R_idx-d_back<0 % jesli max meanQRS jest przy samej krawdzi okna, celuj w rodek okna - clossest approx i can imagine  -Jacek 
        R_val =  meanQRS(floor(length(meanQRS)/2));
        R_idx = floor(length(meanQRS)/2);
    end
    
    line_dot = meanQRS(R_idx-d_back:R_idx-1);
    x_dot = R_idx-d_back:R_idx-1;
    
    a = sum((x_dot-mean(x_dot)).*line_dot)/sum((x_dot-mean(x_dot)).^2);
    b = mean(line_dot)-a*mean(x_dot);
    
    x_fit = 1:R_idx+9;
    y_fit = a*x_fit+b;
  
    %[q_val,q_idx]= max(y_fit>meanQRS(1:length(y_fit))); % not the best 
    [~,q_idx]= min(abs(y_fit-mean(meanQRS(1:R_idx-40))) );
    if q_idx > length(meanQRS) q_idx = R_idx - 20; end % closest approx i can imagine - jacek 
    
    q_val = meanQRS(q_idx);
    
    
    % find begining
    
    %%  sum up field under ecg  - first features - hopeless but features... 
    zero_line_idx = 1:R_idx;
    zero_line = zeros(1,length(zero_line_idx));
    
    amp = sum(meanQRS(1:R_idx));
    abs_amp = sum(abs(meanQRS(1:R_idx)));
    % divide by number of samples to avoid diffrent sampling bias
    mean_amp = amp/R_idx;
    mean_amp_abs = abs_amp/R_idx;
    
    %% find isoelectric line - trialll 
    
    %line before R, backed about d_back points. 
    line_P = meanQRS(1:R_idx-d_back);
    x_P = 1:R_idx-d_back;
    % delete outstanding points to have only isoelectric line without P or
    
    % fluctuations connected with Rwave or q wave - method 1
%     mean_line_P = mean(line_P);
%     std_line_P = std(line_P);
%     factor = 0.7; % czynnik zmienajcy udzia std. im mniejszy tym wiecej punktw wypadnie  
%     x_P(line_P<mean_line_P -factor*std_line_P | line_P > mean_line_P +factor*std_line_P)=[];
%     line_P(line_P<mean_line_P -factor*std_line_P | line_P> mean_line_P +factor*std_line_P)=[];
%     
%     a_P = sum((x_P-mean(x_P)).*line_P)/sum((x_P-mean(x_P)).^2);
%     b_P = mean(line_P)-a_P*mean(x_P);
%     
%     x_Pfit = 1:R_idx;
%     y_Pfit = a_P*x_Pfit+b_P;


    %% fluctuations connected with Rwave or q wave - method 2

    factor = 0.3; % czynnik zmienajcy udzia std. im mniejszy tym wiecej punktw wypadnie  
    % delete points with steep gradient. 
    dline_P = diff(line_P);
    mean_dline_P = mean(dline_P);
    std_dline_P = std(dline_P);
    
    x_P(dline_P<mean_dline_P -factor*std_dline_P | dline_P > mean_dline_P +factor*std_dline_P)=[];
    line_P(dline_P<mean_dline_P -factor*std_dline_P | dline_P> mean_dline_P +factor*std_dline_P)=[];
    %also delete last one point (cose methot above do not work on last point
    x_P(end) = []; 
    line_P(end) = []; 
    
    % now delete points which are at peak P and other strange above
    % thinng... 
     mean_line_P = mean(line_P);      
     std_line_P = std(line_P);
     factor = 0.5; % czynnik zmienajcy udzia std. im mniejszy tym wiecej punktw wypadnie  
     x_P(line_P<mean_line_P -factor*std_line_P | line_P > mean_line_P +factor*std_line_P)=[];
     line_P(line_P<mean_line_P -factor*std_line_P | line_P> mean_line_P +factor*std_line_P)=[];
    
    a_P = sum((x_P-mean(x_P)).*line_P)/sum((x_P-mean(x_P)).^2);
    b_P = mean(line_P)-a_P*mean(x_P);
    
    x_Pfit = 1:q_idx;
    y_Pfit = a_P*x_Pfit+b_P;
    
%     figure(2); plot(x_P,line_P,'k.') % isoelectric line ??
%     hold on; 
%     figure(2); plot(x_Pfit,y_Pfit,'y-') % isoelectric line ??
%     
    % simple method to find simple line 
    
    % point of beginning 
    beginning = mean(meanQRS(1:10)); 
    
    a_simple = (beginning-q_val)/(1-q_idx);
    b_simple = beginning- a_simple*1;
    
    x_simple = 1:q_idx;
    line_simple = a_simple*x_simple+b_simple;
    
%% advanced ploting magic comment this section if not necessary. 
%     figure(1); plot(meanQRS,'.'); hold on; plot(R_idx,R_val,'r*');plot(q_idx,q_val,'g*'); % points
%     figure(1); plot(x_fit,y_fit,'m-') % lin feat not used 
%     figure(1); plot(x_Pfit,y_Pfit,'y-') % isoelectric line ?? 
%      figure(1); plot(x_simple,line_simple,'b-') % isoelectric line ?? 
%     figure(1); plot(zero_line_idx,zero_line,'r-') % zero line 
%     figure(1); plot(diff(meanQRS),'g.') % zero line
%     figure(1); plot(diff(meanQRS),'g-') % zero line
%     title ( ['suma= ' num2str(mean_amp) '....suma bezwzgledna= ' num2str(mean_amp_abs) ' usredniono po... ' num2str(length(peaks)) '... pikach' ]) 
%     ylim([min(meanQRS)-0.5 max(meanQRS)+0.5]);
%     
%     figure(3) % plot zrznicowania qrsw w sygnale. 
%     plot(stdQRS,'.');
%     
    %% features 
    dif_front = sum(abs(diff(meanQRS(1:q_idx))));
    if length(stdQRS) == 1 
        sum_front_std = 0 ; % gnak odchylenia jeli nie byo z czego licczyc 
    else
        sum_front_std =  sum(abs(stdQRS(1:q_idx)));
    end
    
    r_steepnes = a;
    
end