function [mean_amp_abs, mean_amp, dif_front, sum_front_std_av, sum_front_std_av_full,r_steepnes, dynamics, field ] = Pwave_clear(ecg,peaks,fs)
%% feature descriprion
    % 1) sum of field under 1 prat of mean QRS and 2) same, without abs. 
    % 3) sum of steepness of mean qrs first stage. 
    % 4) sum od standard deviation of QRSs to Q
     % 5) sum od standard deviation of FULL QRSs 
    % 6) rsteepness is steepness of R
    % 7) zcr is a dymanics of mean QRS 
   % 8) field is sield over simple isoelectric line     



%% calc. mean QRS
    %normalization
    ecg = (ecg-mean(ecg))/std(ecg);
    
    %%meanQRS $ stdmeanQRS
    
    marginL = floor(0.25*fs); 
    marginR = floor(0.35*fs); 
    qrs_vector = zeros(length(peaks)-2,marginL+marginR+1);
    
    % zabezpieczenie przed exceeds matrix dimensioon 
    peaks(find(peaks+marginR>length(ecg)))=[];
    peaks(find(peaks-marginL<=0))=[];
    
    for i = 1:length(peaks)-1
       qrs_vector(i,:) =  ecg(peaks(i)-marginL: peaks(i)+marginR)';
    end
    %meanQRS = mean(qrs_vector,1);
    
    %umedioanowianie qrsow
    meanQRS = median(qrs_vector,1);
    stdQRS = std(qrs_vector,1);

    % invertion of QRS 
    if(max((meanQRS))<abs(min(meanQRS))); meanQRS = -meanQRS; end
    
        %% peak finding module 
    % find R 
    [R_val,R_idx] = max(meanQRS);
    % find Q 
    % go back 25 ms before R - it allows for linear slope R 
    d_back = round(0.025*fs);
    
    if R_idx-2*d_back<0 % jesli max meanQRS jest przy samej krawdzi okna, celuj w rodek okna - clossest approx i can imagine  -Jacek 
        R_val =  meanQRS(floor(length(meanQRS)/2));
        R_idx = floor(length(meanQRS)/2);
    end
    
    %for linear fit 
    x_dot = R_idx-d_back:R_idx-1;
    line_dot = meanQRS(R_idx-d_back:R_idx-1);
    
    a = sum((x_dot-mean(x_dot)).*line_dot)/sum((x_dot-mean(x_dot)).^2);
    b = mean(line_dot)-a*mean(x_dot);
    
    x_fit = 1:R_idx+9; % +9 just for drawing purposes
    y_fit = a*x_fit+b;
    
    isoelectric_level = mean(meanQRS(1:R_idx-round(0.1*fs))); % beddinind of mean qrs
    [~,q_idx]= min(abs(y_fit-isoelectric_level));
    
    if q_idx > length(meanQRS) q_idx = R_idx - d_back; end % closest approx i can imagine - jacek 
    
    q_val = meanQRS(q_idx);
    
    %% finding acurate isoelectric line 
    % just a line between 2 points on plane
    a_simple = (isoelectric_level-q_val)/(1-q_idx);
    b_simple = isoelectric_level- a_simple*1;
    
    x_simple = 1:q_idx;
    line_simple = a_simple*x_simple+b_simple;
    
    
    %% features
    % 1) sum of field under 1 prat of mean QRS and 2) same, without abs. 
    amp = sum(meanQRS(1:R_idx-d_back));
    abs_amp = sum(abs(meanQRS(1:R_idx-d_back)));
    % divide by number of samples to avoid diffrent sampling bias
    mean_amp = amp/(R_idx-d_back);
    mean_amp_abs = abs_amp/(R_idx-d_back);
    
    % 3) sum of steepness of mean qrs first stage. 
    dif_front = sum(abs(diff(meanQRS(1:q_idx))));
    
    % 4) sum od standard deviation of QRSs to Q
    if length(stdQRS) == 1 
        sum_front_std_av = 0; % gnak odchylenia jeli nie byo z czego licczyc 
         
    else
        sum_front_std =  sum(abs(stdQRS(1:q_idx)));
        sum_front_std_av = sum_front_std/length(stdQRS(1:q_idx));
    end
    
     % 5) sum od standard deviation of FULL QRSs 
    if length(stdQRS) == 1 
        sum_front_std_av_full = 0; % gnak odchylenia jeli nie byo z czego licczyc 
         
    else
        sum_front_std_full =  sum(abs(stdQRS));
        sum_front_std_av_full = sum_front_std_full/length(stdQRS);
    end
    
    % 6) rsteepness is steepness of R
    r_steepnes = a;
    
    % 7) zcr is a dymanics of mean QRS 
   [ZCs, ~] = noise_checker_better(meanQRS);
   dynamics = ZCs; 
   
   % 8) field is sield over simple isoelectric line 
   field = sum(meanQRS(meanQRS(1:q_idx)>line_simple)); 
   
end