function  [ifO] = checkOtherPreliminary_v2(ecg, QRS,fs)
%PRELIMINARY detection of other rhythm
% WHAT'S is detected:
%   - bradycardia
%   - tachycardia
%   - subventricular and subatrial ectopy beats

        ifO=0;
        RR=diff(QRS)/fs*1000;
        
    %% BRADYCARDIA & TACHYCARDIA

        n10perc = ceil(length(RR)*0.1);
        RRsort=sort(RR);
        if(length(RRsort)>5)
            RRsort=RRsort(n10perc:end-n10perc);
            meanRR=mean(RRsort);
            meanRRRR=mean(diff(RR));
            pNN = sum(diff(RR)>50)/length(diff(RR))*100;
            HR = 60/(meanRR/1000);
            
            if( (HR < 50 && pNN < 25 ) || (HR > 100 && pNN < 15 ))
                ifO=1;
            end
            
        end
    
    %% SUBVENTRICULAR AND SUBATRIAL ECTOPY BEATS
%     
%     % 1) pattern 1) -/\-
    RRsort=sort(RR);
    RRsort=RRsort(n10perc:end-n10perc);
    pNN = sum(diff(RR)>50)/length(diff(RR))*100;
    pat1counter=0;
    pat2counter=0;
    pat3counter=0;
    pat4counter=0;
    
        for i=1:length(RR)-3
           
            %single atrial or ventricular preliminary beat
            if(RR(i)>RR(i+1) && RR(i+1)<RR(i+2) && RR(i)<RR(i+2) && RR(i+3)<RR(i+2) && RR(i+3)>RR(i+1) && abs(RR(i)-RR(i+3))<=30  ...
                    && abs(RR(i)-RR(i+1))>=250 )
                
                pat1counter=pat1counter+1;
            end
            
            %periodicity of ectopic beats
            if(RR(i)<RR(i+1) && RR(i+1)>RR(i+2) && abs(RR(i)-RR(i+2))<=25 && abs(RR(i+3)-RR(i+1))<=25 && abs(RR(i)-RR(i+1))>=200)
                pat2counter=pat2counter+1;
            end
            
            if(RR(i)<RR(i+1) && RR(i+1)>RR(i+2) && RR(i+2)>RR(i+3) && abs(RR(i)-RR(i+3))<=25  && abs(RR(i)-RR(i+1))>=200 && abs(RR(i+1)-RR(i+2))>=200)
                pat3counter=pat3counter+1;
            end
            
            if(RR(i)<RR(i+1) && RR(i+1)>RR(i+2) && abs(RR(i)-RR(i+2))<=25 && abs(RR(i)-RR(i+1))>=200 && abs(RR(i+1)-RR(i+3))<=40)
                pat4counter=pat4counter+1;
            end
            
%             if(RR(i)<RR(i+1) && RR(i+1)>RR(i+2) && abs(RR(i)-RR(i+2))<=25 && abs(RR(i+3)-RR(i+1))<=25 && abs(RR(i)-RR(i+1))>=200)
%                 pat2counter=pat2counter+1;
%             end
            
        end
    
%     if(pat1counter>2 || pat2counter>3 || pat3counter>3 || pat4counter>5) ifO=1; end
if(pat1counter>1 || pat2counter>2 || pat3counter>2 || pat4counter>2) ifO=1; end
 

