%GENERATE_FEATURES 
% Functions that you need to run this script:
% hybrid_detection.m
% comput_AFEv_mod.m
% comp_dRR.m
% metrics.m
% line_cross.m

    % loading data from training set
    dir_path = '..\training2017';
    %dir_path = ['..' filesep 'training2017'];
    files = dir([dir_path filesep '*.mat']);
    
    % loadind references from a csv file
    path = ([dir_path filesep 'REFERENCE-v2.csv']);
    
    fid = fopen(path, 'r');
    if(fid ~= -1)
        temp = textscan(fid,'%s %s','Delimiter',',');
    else
        error(['Could not open ' path ' for scoring. Exiting...'])
    end
    fclose(fid);
    
    names = temp{1};
    real_values  = temp{2};

    fs = 300; %sampling frequency
    
    features = [];
    featuresALL = [];
    counter_RR4 = 0;
    counter_RR6 = 0;
    
    for i = 1 : length(files)
        
        sig = load( [dir_path filesep files(i).name]);
        disp(files(i).name);
        [pathstr, name, ~] = fileparts(files(i).name);
        
        str_real_values = char(real_values);
        
        % falki 
        Y = upcoef('d',sig.val,'db6',2);
        ecg_falkowe = Y(1:4:end);
        %sig.val = Y(1:4:end);
        
        % hybrid detection - consists qrs_detect2 & rpeakdetection (FOGD)
        peakI = hybrid_detection(ecg_falkowe, fs);
        RR = diff(peakI')/fs; % RR intervals
        
        if length(RR) < 4
            counter_RR4 = counter_RR4 + 1;
        end
        if length(RR) < 6
            counter_RR6 = counter_RR6 + 1;
        end
        
        if length(RR) < 6
            %features = zeros(47,1)';
        else
        % calculating features

%         [~, features_AF] = comput_AFEv_mod(RR);
%         dRR = comp_dRR(RR);
%         [OriginPercent,PP_vect, BP_vect] = metrics_mod3(dRR);
%         [OriginDiff,PBDiff] = metrics_mod4(dRR);

            RR_dla_AFEv = RR;
            if length(sig.val)/300 < 29
                RR_dla_AFEv = [RR; RR];
            end

         [features_AF] = comput_AFEv(RR_dla_AFEv);
         [feature_x, feature_xm] = line_cross(peakI, fs);
         features_lepek = lepeksGreaterSetOfFeatures2(RR);
         
         features_jacek = moreSimpleFeaturesByJack(RR);
         
         [features_sampen_rr,~] = sampen(RR,5,0.2,1,0,0);
         
         % first Pwave
         %[mean_amp_abs, mean_amp, dif_front, sum_front_std, r_steepnes] = Pwave(sig.val, peakI, fs);
         %features_Pwave = [mean_amp_abs, mean_amp, dif_front, sum_front_std, r_steepnes];
         
         % Pwave_clear
         [mean_amp_abs, mean_amp, dif_front, sum_front_std_av, sum_front_std_av_full, r_steepnes, dynamics, field ] = Pwave_clear(sig.val, peakI, fs);
         features_Pwave = [mean_amp_abs, mean_amp, dif_front, sum_front_std_av, sum_front_std_av_full, r_steepnes, dynamics, field];
         
         % Pwave_clear_advanced
         [mean_amp_abs2, mean_amp2, dif_front2, sum_front_std_av2, sum_front_std_av_full2, dynamics2, field2 ] = Pwave_clear_advanced(sig.val, peakI, fs);
         features_Pwave_advanced = [mean_amp_abs2, mean_amp2, dif_front2, sum_front_std_av2, sum_front_std_av_full2, dynamics2, field2];
         
         
         features = [features_AF feature_x feature_xm features_lepek ...
             features_jacek features_sampen_rr'  features_Pwave features_Pwave_advanced ];
         
        
        
%        features = [OriginDiff PBDiff];
%         features = features_AF;
        
        switch str_real_values(i)
            case 'N'
                result = ('normal rhythm');
                features = [features  1 0 0];

            case 'O'
                result = ('other rhythm');
                features = [features  0 0 1];

            case 'A'
                result = ('AF rhythm');
                features = [features  0 1 0];
            case '~'
                result = ('noisy recording');
                features = [];
        end
        featuresALL = [featuresALL ; features];
        
        end
    end

dlmwrite('./featuresALL_entry3_Pwaveobaifalki.txt',featuresALL,'delimiter','\t');

counter_RR4
counter_RR6
