function [histogram_ecg, centers, D, sum_hist] = hist_gaussfit(ecg)
%HIST_GAUSSFIT 

    ecg = ecg/std(ecg); 
    edges = linspace(-8,8,100);
    [histogram_ecg, edges] = histcounts(ecg, edges);
    centers = (edges(2:end)-edges(1:end-1))/2 + edges(1:end-1);
    histogram_ecg = histogram_ecg/max(histogram_ecg);
  
     f = fit(centers.',histogram_ecg.','gauss2');
     a1 = f.a1;
     b1 = f.b1;
     c1 = f.c1;
     a2 = f.a2;
     b2 = f.b2;
     c2 = f.c2;
     func =  a1*exp(-((centers-b1)/c1).^2) + a2*exp(-((centers-b2)/c2).^2);
 
    % Left side
    [~,minInx] = min(abs(func(1:50)-0.1));
    dLeft = minInx;
    
    % Right side
    [~,minInx] = min(abs(func(51:end)-0.1));
    dRight = 50+minInx;
    
    D = dRight-dLeft;
    
    sum_hist = sum(histogram_ecg);
    
%     if D > 16 % empirical parameter
%         noise_flag = 1;
%     else
%         noise_flag = 0;
%     end
    
end

