function [peak_final] = hybrid_detection(sig, fs)
%HYBRID_DETECTION - combination of two methods of R peak detection
% superior detection - R peak detection (FOGD)
% inferior detection - QRS detect 2
% by Ania & Jacek 
% Last modification: 05.04.17
    
    [peak_RPD] = rpeakdetect_pub(sig, fs, 6, 20);
    [peak_QD2,~,~] = qrs_detect2(sig, 0.250,0.6,fs,'','', 0);    
    
    peaks_toremove = [];
    for i = 1 : length(peak_RPD)
        peaks_toremove = [peaks_toremove find(peak_QD2 > peak_RPD(i) - 75 & peak_QD2 < peak_RPD(i) + 75)];
    end
    peak_QD2(peaks_toremove) = [];
    
    peak_final = [peak_QD2 peak_RPD];
    peak_final = sort(peak_final);
end

