function features = lepeksGreaterSetOfFeatures2(RR)
%function features = lepeksGreaterSetOfFeatures(RR, ECG)

meanRR = mean(RR);
stddevRR = std(RR);
minRR = min(RR);
maxRR = max(RR);

RRnormalized = (RR-mean(RR))/std(RR);
%ECGnormalized = (ECG-mean(ECG))/std(ECG);

maxgradRR = max(gradient(RRnormalized));
mingradRR = min(gradient(RRnormalized));
meangradRR = mean(abs(gradient(RRnormalized)));

%meangradECG = mean(abs(gradient(ECGnormalized)));
%maxabsgradECG = max(abs(gradient(ECGnormalized)));

h = hist(RR-meanRR,5);
h = h * 1/sum(h); % normalizacja
h = h(:)';

lenRR = length(RR);
%lenECG = length(ECG);
%lenratio = lenRR/lenECG;

%ECGtemp = ECGnormalized+2;
%ZCsECGplus = 2*length(find((ECGtemp(1:end-1) > 0) & (ECGtemp(2:end) < 0)))/length(ECGtemp);
%ECGtemp = ECGtemp-4;
%ZCsECGminus = 2*length(find((ECGtemp(1:end-1) > 0) & (ECGtemp(2:end) < 0)))/length(ECGtemp);

ZCsRR = 2*length(find((RRnormalized(1:end-1) > 0) & (RRnormalized(2:end) < 0)))/length(RR);

%quantile02ECG = quantile(ECGnormalized, 0.2);
%quantile05ECG = quantile(ECGnormalized, 0.5);
%quantile07ECG = quantile(ECGnormalized, 0.7);

quantile02RR = quantile(RRnormalized, 0.2);
quantile05RR = quantile(RRnormalized, 0.5);
quantile07RR = quantile(RRnormalized, 0.7);

%stdevECG = std(ECG);

RMSSD1RR = sqrt(sum((RRnormalized(1:end-1) - RRnormalized(2:end)).^2)/lenRR);
RMSSD2RR = sqrt(sum((RRnormalized(1:end-2) - RRnormalized(3:end)).^2)/lenRR);
RMSSD3RR = sqrt(sum((RRnormalized(1:end-3) - RRnormalized(4:end)).^2)/lenRR);
RMSSD5RR = sqrt(sum((RRnormalized(1:end-5) - RRnormalized(6:end)).^2)/lenRR);

%{
ECG_window = ECGnormalized(1:floor(length(ECG)/2));
ECG_window_len = length(ECG_window);
meancorrECG = 0;
maxcorrECG = -1;
mincorrECG = 1;
i = 1 + 5*300; % poczatkowy lag 5s
licznik = 1;
while i+ECG_window_len < lenECG
	kor = corr(ECG_window, ECGnormalized(i:i+ECG_window_len-1));
	meancorrECG = meancorrECG + kor;
	if kor > maxcorrECG
		maxcorrECG = kor;
	elseif kor < mincorrECG
		mincorrECG = kor;
	end
	licznik = licznik + 1;
    i = i+1;
end
meancorrECG = meancorrECG/licznik;
%}
%
RR_window = RRnormalized(1:floor(length(RR)/2));
RR_window_len = length(RR_window);
meancorrRR = 0;
maxcorrRR = -1;
mincorrRR = 1;
i = 2; % poczatkowy lag jedno RR
licznik = 1;
while i+RR_window_len < lenRR
	kor = corr(RR_window, RRnormalized(i:i+RR_window_len-1));
	meancorrRR = meancorrRR + kor;
	if kor > maxcorrRR
		maxcorrRR = kor;
	elseif kor < mincorrRR
		mincorrRR = kor;
	end
	licznik = licznik + 1;
    i = i + 1;
end
meancorrRR = meancorrRR/licznik;
%}

if length(RR) > 3
    RRsorted = sort(RR);
    meanOf3shortest = mean( RRsorted(1:3) );
    meanOf3longest = mean( RRsorted(end-2:end) );
else
    meanOf3shortest = mean(RR);
    meanOf3longest = mean(RR);
end

features = [ ...
meanRR, stddevRR, minRR, maxRR, maxgradRR, mingradRR, meangradRR ...
...%meangradECG, maxabsgradECG, stdevECG, ...
h ...
...%lenratio, ...
...%ZCsECGplus, ZCsECGminus, ...
ZCsRR ...
...%quantile02ECG, ...
...%quantile05ECG, ...
...%quantile07ECG ...
quantile02RR ...
quantile05RR ...
quantile07RR ...
RMSSD1RR ...
RMSSD2RR ...
RMSSD3RR ...
RMSSD5RR ...
meancorrRR, mincorrRR, maxcorrRR, ...
meanOf3shortest, meanOf3longest, ...
...%meancorrECG, maxcorrECG, mincorrECG, ...
];

features = features(:)';
